#include <stdio.h>

int main(void)
{
  unsigned int buf[] = {
    0x45, 0,
    0, 0x1d,
    0, 0,
    0x40, 0,
    0x40, 0x11,
    0x78, 0xc4,  /* checksum */
    0xc0, 0xa8, 0x01, 0x64,
    0xff, 0xff, 0xff, 0xff
  };
  unsigned int sum = 0;
  int i;
  for (i = 0; i < sizeof(buf)/sizeof(unsigned int); i+=2) {
    unsigned int z = (buf[i] << 8) + buf[i+1];
    sum+=z;
  }
  while (sum >> 16) sum = (sum >> 16) + (sum & 0xffff);
  //sum = (sum >> 16) + (sum & 0xffff);
  sum = ~sum;
  sum &= 0xffff;
  printf("%4.4x\n", sum);
  return 0;
}
