#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

int main(int n, char **v)
{
  char buf[512];
  FILE *in, *out;
  struct stat sbuf;
  char *infile, *outfile;
  if (n!=3) { printf("gimme <infile> <outfile>\n"); return 1; }
  infile = v[1];
  outfile = v[2];
  in = fopen(infile, "r");
  if (in == NULL) { perror(infile); return 1; }
  if (fstat(fileno(in), &sbuf) != 0) { perror(infile); return 1; }
  //if (sbuf.st_size > 510) { printf("%s: file too big\n", infile); return 1; }
  if (sbuf.st_size > 510) sbuf.st_size = 510;
  memset(buf, 0, sizeof(buf));
  if (fread(buf, 1, sbuf.st_size, in) != sbuf.st_size)
    { printf("error reading %s\n", infile); return 1; }
  fclose(in);
  buf[510] = 0x55;
  buf[511] = 0xaa;
  out = fopen(outfile, "w"); if (out == NULL) { perror(outfile); return 1; }
  if (fwrite(buf, 1, 512, out) != 512)
    { printf("error writing %s\n", outfile); return 1; }
  if (fclose(out)) { perror(outfile); return 1; }
  return 0;
}
